Time#localtime doesn't always seem to respect TZ
Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

DONE

Description

In the first case, calling #localtime doesn't change the utc_offset.

$ TZ=UTC ruby -e 'ENV["TZ"]="Pacific/Auckland"; puts t=Time.new; ENV["TZ"]="UTC"; puts t.localtime

'                                            

2018-06-29 16:21:36 +1200

2018-06-29 16:21:36 +1200

$ TZ=UTC ruby -e 'ENV["TZ"]="Pacific/Auckland"; puts t=Time.new; ENV["TZ"]="UTC"; puts Time.new(t.

year, t.month, t.day, t.hour, t.min, t.sec, t.utc_offset).localtime'

2018-06-29 16:23:08 +1200

2018-06-29 04:23:08 +0000

 In the second case, by creating new time, calling #localtime works as expected.

It seems like once a time instance is "localtime", calling #localtime a 2nd time does not have any effect.

Associated revisions

Revision 482bbde6e25620b340e28423c08e3cee941c438b - 07/02/2018 07:46 AM - nobu (Nobuyoshi Nakada)

time.c: [DOC] Time#localtime

time.c: state that Time#localtime does nothing when nothing

changes.  [ruby-core:87675] [Bug #14880]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63823 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 482bbde6e25620b340e28423c08e3cee941c438b - 07/02/2018 07:46 AM - nobu (Nobuyoshi Nakada)

time.c: [DOC] Time#localtime

time.c: state that Time#localtime does nothing when nothing

changes.  [ruby-core:87675] [Bug #14880]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63823 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 482bbde6 - 07/02/2018 07:46 AM - nobu (Nobuyoshi Nakada)

time.c: [DOC] Time#localtime

time.c: state that Time#localtime does nothing when nothing

changes.  [ruby-core:87675] [Bug #14880]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63823 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4f0899d4bba4a03c4de45e742f9e37a89b8b32e2 - 01/10/2019 02:46 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 63823,63839: [Backport #14890]

    time.c: [DOC] Time#localtime

    * time.c: state that Time#localtime does nothing when nothing

      changes.  [ruby-core:87675] [Bug #14880]

    skip test_localtime_zone if force_tz_test is false
    For example Solaris

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable10x/ruby-trunk/log/20180703T091803Z.fail.html.gz

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@66780 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4f0899d4bba4a03c4de45e742f9e37a89b8b32e2 - 01/10/2019 02:46 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 63823,63839: [Backport #14890]

    time.c: [DOC] Time#localtime

    * time.c: state that Time#localtime does nothing when nothing

      changes.  [ruby-core:87675] [Bug #14880]

    skip test_localtime_zone if force_tz_test is false

    For example Solaris

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable10x/ruby-trunk/log/20180703T091803Z.fail.html.gz

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@66780 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4f0899d4 - 01/10/2019 02:46 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 63823,63839: [Backport #14890]

    time.c: [DOC] Time#localtime

    * time.c: state that Time#localtime does nothing when nothing

      changes.  [ruby-core:87675] [Bug #14880]

    skip test_localtime_zone if force_tz_test is false

    For example Solaris

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable10x/ruby-trunk/log/20180703T091803Z.fail.html.gz

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@66780 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/02/2018 07:46 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r63823.

time.c: [DOC] Time#localtime

time.c: state that Time#localtime does nothing when nothing

changes.  [ruby-core:87675] [Bug #14880]

#2 - 08/27/2018 04:29 AM - ioquatix (Samuel Williams)

@nobu (Nobuyoshi Nakada) Isn't changing TZ enough that #localtime should do something?

#3 - 08/31/2018 06:43 AM - nobu (Nobuyoshi Nakada)

I think it should be fixed at the creation time.

#4 - 08/31/2018 08:54 AM - ioquatix (Samuel Williams)

@nobu (Nobuyoshi Nakada) That doesn’t seem to align with what the documentation says:

Converts time to local time (using the local time zone in effect for this process) modifying the receiver.

#5 - 09/03/2018 07:41 AM - nobu (Nobuyoshi Nakada)

I feel it'd be better to accept a timezone object as utc_offset like [Feature #14850], than setting ENV.

#6 - 09/03/2018 09:07 AM - ioquatix (Samuel Williams)

nobu (Nobuyoshi Nakada) wrote:
I feel it'd be better to accept a timezone object as utc_offset like [Feature #14850], than setting ENV.

 I completely agree but the problem is how to compute utc offset for a given time and timezone.

Right now using TZ is the only way to do it.

#7 - 01/10/2019 02:47 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: UNKNOWN to 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: DONE

ruby_2_5 r66780 merged revision(s) 63823,63839.

Powered by TCPDF (www.tcpdf.org)

05/18/2025 3/3

https://redmine.ruby-lang.org/issues/14850
http://www.tcpdf.org

